%define anolis_release 43

Name: grubby
Version: 8.40
Release: %{anolis_release}%{?dist}
Summary: Command line tool for updating bootloader configs
Group: System Environment/Base
License: GPLv2+
URL: https://github.com/rhboot/grubby
Source0: https://github.com/rhboot/grubby/archive/refs/tags/%{name}-%{version}-1.tar.gz
Source1: grubby-bls
Source2: grubby.in
Source3: installkernel.in
Source4: installkernel-bls
Source5: 95-kernel-hooks.install
Source6: 10-devicetree.install
Source7: grubby.8

Patch0001: 0001-Fix-GCC-warnings-about-possible-string-truncations-a.patch
Patch0002: 0002-Fix-stringop-overflow-warning.patch
Patch0003: 0003-Fix-maybe-uninitialized-warning.patch
Patch0005: 0005-Use-system-LDFLAGS.patch
Patch0006: 0006-Honor-sbindir.patch
Patch0007: 0007-Make-installkernel-to-use-kernel-install-scripts-on-.patch
Patch0008: 0008-Add-usr-libexec-rpm-sort.patch
Patch0009: 0009-Fix-build-with-rpm-4.16.patch

Patch1000: 1000-grubby-support-anolis.patch

BuildRequires: pkgconfig glib2-devel popt-devel 
BuildRequires: libblkid-devel git
# for make test / getopt:
BuildRequires: util-linux-ng
BuildRequires: grub2-tools-minimal
BuildRequires: rpm-devel

Requires: grub2-tools-minimal
Requires: grub2-tools
Requires: findutils
Requires: util-linux

%description
grubby  is  a command line tool for updating and displaying information about 
the configuration files for the grub, lilo, elilo (ia64),  yaboot (powerpc)  
and zipl (s390) boot loaders. It is primarily designed to be used from scripts
which install new kernels and need to find information about the current boot 
environment.

%package deprecated
Summary:    Legacy command line tool for updating bootloader configs
Conflicts:  %{name} < 8.40

%description deprecated
This package provides deprecated, legacy grubby.  This is for temporary
compatibility only.

grubby is a command line tool for updating and displaying information about
the configuration files for the grub, lilo, elilo (ia64), yaboot (powerpc)
and zipl (s390) boot loaders. It is primarily designed to be used from
scripts which install new kernels and need to find information about the
current boot environment.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version}-1 -p1

%build
%make_build

%ifnarch aarch64
%check
make test
%endif

%install
%make_install mandir=%{_mandir} sbindir=%{_sbindir} libexecdir=%{_libexecdir}

mkdir -p %{buildroot}%{_libexecdir}/{grubby,installkernel}/ %{buildroot}%{_sbindir}/
mv -v %{buildroot}%{_sbindir}/grubby %{buildroot}%{_libexecdir}/grubby/grubby
mv -v %{buildroot}%{_sbindir}/installkernel %{buildroot}%{_libexecdir}/installkernel/installkernel
install -m 0755 %{SOURCE1} %{buildroot}%{_libexecdir}/grubby/
install -m 0755 %{SOURCE4} %{buildroot}%{_libexecdir}/installkernel/
sed -e "s,@@LIBEXECDIR@@,%{_libexecdir}/grubby,g" %{SOURCE2} \
        > %{buildroot}%{_sbindir}/grubby
sed -e "s,@@LIBEXECDIR@@,%{_libexecdir}/installkernel,g" %{SOURCE3} \
        > %{buildroot}%{_sbindir}/installkernel
install -D -m 0755 -t %{buildroot}%{_prefix}/lib/kernel/install.d/ %{SOURCE5}
install -D -m 0755 -t %{buildroot}%{_prefix}/lib/kernel/install.d/ %{SOURCE6}
rm %{buildroot}%{_mandir}/man8/grubby.8*
install -m 0644 %{SOURCE7} %{buildroot}%{_mandir}/man8/

%files
%license COPYING
%dir %{_libexecdir}/grubby
%dir %{_libexecdir}/installkernel
%attr(0755,root,root) %{_libexecdir}/grubby/grubby-bls
%attr(0755,root,root) %{_libexecdir}/grubby/rpm-sort
%attr(0755,root,root) %{_sbindir}/grubby
%attr(0755,root,root) %{_libexecdir}/installkernel/installkernel-bls
%attr(0755,root,root) %{_sbindir}/installkernel
%attr(0755,root,root) %{_prefix}/lib/kernel/install.d/10-devicetree.install
%attr(0755,root,root) %{_prefix}/lib/kernel/install.d/95-kernel-hooks.install
%{_mandir}/man8/[gi]*.8*

%files deprecated
%dir %{_libexecdir}/grubby
%dir %{_libexecdir}/installkernel
%attr(0755,root,root) %{_libexecdir}/grubby/grubby
%attr(0755,root,root) %{_libexecdir}/installkernel/installkernel
%attr(0755,root,root) %{_sbindir}/grubby
%attr(0755,root,root) %{_sbindir}/installkernel
%attr(0755,root,root) %{_sbindir}/new-kernel-pkg
%{_mandir}/man8/*.8*

%files doc
%doc TODO

%changelog
* Mon Jan 2 2023 Funda Wang <fundawang@yeah.net> - 8.40-43
- Bump release for upgrading from anolis 8

* Fri Dec 2 2022 yuanhui <yuanhui@linux.alibaba.com> - 8.40-4
- Add doc package for grubby

* Mon Mar 28 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 8.40-3
- set bls related command for default
- traditional grub/installkernel move to deprecated packages

* Mon Mar 28 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 8.40-2
- grubby support anolis

* Wed Mar  9 2022 Liwei Ge <liwei.glw@linux.alibaba.com> - 8.40-1
- Init version from upstream v8.40
